print '---------------------------------------- Trend Micro Canada ---------------------------------------';
print '******************* Executing Migration Space Requirement Script ********************';
print '  ';
print '  ';
print '  ';
print '  ';
GO

print 'SQL Server Remote Query Timeout=$(REMOTE_QUERY_TIMEOUT)';
print 'This script will operate on database=$(TENANT_DB_NAME)';
GO












-- ///////////////////////////////////////////////////////////////////////////
-- Modify this line to correct DSM database name.
use [$(TENANT_DB_NAME)]
go
-- ///////////////////////////////////////////////////////////////////////////
set nocount on
go
-- ///////////////////////////////////////////////////////////////////////////
declare @tableMigrationTarget table (tablename nvarchar(max));
insert into @tableMigrationTarget (tablename) values ('systemevents'),
                                                     ('antimalwareevents'),
                                                     ('antimalwarequarantinedfile'),
                                                     ('antimalwarespywareitems'),
                                                     ('antimalwareeventhistory'),
                                                     ('integrityevents'),
                                                     ('integrityeventhistory'),
                                                     ('loginspectionevents'),
                                                     ('loginspectioneventhistory'),
                                                     ('packetlogs'),
                                                     ('packetlogdatas'),
                                                     ('packetloghistory'),
                                                     ('payloadlogs'),
                                                     ('payloadlogdatas'),
                                                     ('payloadloghistory'),
                                                     ('webreputationevents'),
                                                     ('webreputationeventhistory')
-- ///////////////////////////////////////////////////////////////////////////
declare @tableSpaceSummary table (tableName nvarchar(max)
                                 ,schemaName nvarchar(max)
                                 ,rowCounts bigint
                                 ,spaceKbTotal bigint
                                 ,spaceKbUsed bigint
                                 ,spaceKbUnused bigint);
-- ///////////////////////////////////////////////////////////////////////////
insert into @tableSpaceSummary
select t.name as tablename,
       s.name as schemaname,
       p.rows as rowcounts,
       sum(a.total_pages) * 8 as totalspacekb,
       sum(a.used_pages) * 8 as usedspacekb,
       (sum(a.total_pages) - sum(a.used_pages)) * 8 as unusedspacekb
from sys.tables t
inner join sys.indexes i on t.object_id = i.object_id
inner join sys.partitions p on i.object_id = p.object_id and i.index_id = p.index_id
inner join sys.allocation_units a on p.partition_id = a.container_id
left outer join sys.schemas s on t.schema_id = s.schema_id
where t.name not like 'dt%'
  and t.is_ms_shipped = 0
  and i.object_id > 255
  and t.name in (select * from @tableMigrationTarget)
group by t.name, s.name, p.rows
-- ///////////////////////////////////////////////////////////////////////////
declare @sizeTotalyUsedInKb bigint = 0;
declare @sizeTotalyUsedInMb bigint = 0;
declare @sizeTotalyUsedInGb bigint = 0;
select @sizeTotalyUsedInKb = sum(spaceKbUsed) from @tableSpaceSummary
print 'Total Disk Usage for Migration Tables in KB : ' + cast(@sizeTotalyUsedInKb as nvarchar) + ' KB'
set @sizeTotalyUsedInMb = @sizeTotalyUsedInKb / 1024;
print 'Total Disk Usage for Migration Tables in MB : ' + cast(@sizeTotalyUsedInMb as nvarchar) + ' MB'
set @sizeTotalyUsedInGb = @sizeTotalyUsedInMb / 1024;
print 'Total Disk Usage for Migration Tables in GB : ' + cast(@sizeTotalyUsedInGb as nvarchar) + ' GB'
-- ///////////////////////////////////////////////////////////////////////////
set nocount off
go















print '  ';
print '  ';
print '  ';
print '  ';
print '******************** Finished Executing Table Usage Script ********************';
print '  ';
print '  ';
print '  ';
print '  ';
GO



print '---------------------------------------- Sending Quit to SQLCMD ----------------------------------------'
GO

:quit
